/*
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * AbstractRealDistribution.java
 * Copyright (C) 2014 University of Waikato, Hamilton, New Zealand
 */

package adams.data.distribution;

import org.apache.commons.math3.distribution.RealDistribution;

import adams.core.option.AbstractOptionHandler;

/**
 * Ancestor for distributions.
 *
 * @author  fracpete (fracpete at waikato dot ac dot nz)
 * @version $Revision$
 */
public abstract class AbstractRealDistribution
  extends AbstractOptionHandler {

  /** for serialization. */
  private static final long serialVersionUID = -2791338418373425167L;

  /** the underlying distribution. */
  protected RealDistribution m_Distribution;

  /**
   * Returns the configured distribution.
   *
   * @return		the distribution
   */
  public abstract RealDistribution getRealDistribution();
}
